/*  XRoar - a Dragon/Tandy Coco emulator
 *  Copyright (C) 2003-2004  Ciaran Anscomb
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <SDL/SDL.h>

#include "types.h"
#include "joystick.h"
#include "pia.h"
#include "logging.h"

SDL_Joystick *joy = NULL;

void joystick_init_arch(void) {
	SDL_InitSubSystem(SDL_INIT_JOYSTICK);
	LOG_DEBUG(1,"Number of joysticks: %d\n", SDL_NumJoysticks());
	if (SDL_NumJoysticks() > 0) {
		joy = SDL_JoystickOpen(0);
		if (joy) {
			LOG_DEBUG(2,"Opened Joystick 0\n");
			LOG_DEBUG(0,"Joystick name: %s\n", SDL_JoystickName(0));
			LOG_DEBUG(2,"Number of Axes: %d\n", SDL_JoystickNumAxes(joy));
			LOG_DEBUG(2,"Number of Buttons: %d\n", SDL_JoystickNumButtons(joy));
			LOG_DEBUG(2,"Number of Balls: %d\n", SDL_JoystickNumBalls(joy));
		}
	}
}

void joystick_poll(void) {
	if (joy == NULL)
		return;
	SDL_JoystickUpdate();
	joystick_leftx = (SDL_JoystickGetAxis(joy, 3)+32768) >> 8;
	joystick_lefty = (SDL_JoystickGetAxis(joy, 2)+32768) >> 8;
	joystick_rightx = (SDL_JoystickGetAxis(joy, 0)+32768) >> 8;
	joystick_righty = (SDL_JoystickGetAxis(joy, 1)+32768) >> 8;
	if (SDL_JoystickGetButton(joy, 1)) {
		PIA_0A.tied_low &= 0xfe;
	} else {
		PIA_0A.tied_low |= 0x01;
	}
	if (SDL_JoystickGetButton(joy, 0)) {
		PIA_0A.tied_low &= 0xfd;
	} else {
		PIA_0A.tied_low |= 0x02;
	}
}
