/*  XRoar - a Dragon/Tandy Coco emulator
 *  Copyright (C) 2003-2004  Ciaran Anscomb
 *
 *  See COPYING for redistribution conditions. */

#ifndef __TYPES_H__
#define __TYPES_H__

#ifdef GP32  /* GP32 types & macros */

#include <gpstdlib.h>
#include <gpstdio.h>
#include <string.h>

#define WRONG_ENDIAN

#define malloc gm_malloc
#define free gm_free
/*
#define memset gm_memset
#define memcpy gm_memcpy
*/
#define exit(r)
#define fprintf(...)
#define printf(...)

typedef unsigned char Uint8;
typedef unsigned short Uint16;
typedef unsigned int Uint32;
typedef char Sint8;
typedef short Sint16;
typedef int Sint32;

typedef F_HANDLE FILER_FD;
typedef struct {
	GPFILEATTR attr;
	char name[16];
} FILER_DIRENT;
extern FILER_DIRENT *filer_directory;
extern Uint32 filer_dir_count;

#else  /* Unix types & macros */

#include <string.h>
#include <SDL/SDL_types.h>

typedef int FILER_FD;

#endif  /* Tests for architecture */

#endif  /* __TYPES_H__ */
